/***************************************************************************
 **
 **    This file defines the board specific definition
 **    ST MB460 board (STR910)
 **
 **    Used with ARM IAR C/C++ Compiler and Assembler.
 **
 **    (c) Copyright IAR Systems 2006
 **
 **    $Revision: 1.0 $
 **
 ***************************************************************************/

#ifndef __BOARD_H
#define __BOARD_H

// Pll cfg
#define M                   25UL    // PLL Pre-divider
#define P                   2UL     // PLL Post-divider
#define N                   192UL   // PLL Feedback divider

// ARM_CLK
#define CORE_CLK            (96MHZ)
// HCLK CORE_CLK
#define AHB_CLK             (CORE_CLK)
// PER_CLK
#define PER_CLK             (CORE_CLK/2UL)
// RTC_CLK
#define RTC_CLK             32768UL

// Timer 0 tick per seconds
#define TIM_0_RES           20UL
#define TIM_PSC(Val)        ((PER_CLK*Val)/1000000UL)

// Timer Ticks per second
#define TICK_PER_SEC        100
#define TIM0_PER(Val)       (1000000UL/(Val*TIM_0_RES))

#endif /* __BOARD */
