/**************************************************
 *
 * This is a template file.
 *
 * Copyright 1998 IAR Systems. All rights reserved.
 *
 * $Revision: 1.0 $
 *
 **************************************************/

/** include files **/
#include "adc.h"

Int32U Val_Watch;

typedef struct _AdcThresholds_t
{
  Int32U Min;
  Int32U Max;
} AdcThresholds_t, * pAdcThresholds_t;

const Int8U ConvChannels[] =
{
  ADC_Channel_0,
  ADC_Channel_1,
  ADC_Channel_2,
  ADC_Channel_3,
  0xFF
};

const AdcThresholds_t AdcThresholds[(sizeof(ConvChannels)/sizeof(ConvChannels[0]))-1] =
{
  {.Min = 800, .Max = 840},
  {.Min = 590, .Max = 630},
  {.Min = 388, .Max = 428},
  {.Min = 182, .Max = 222},
};


// Local functions prototype

// Local data

Int32U AdcConvertion(Int32U Channel)
{
ADC_InitTypeDef   ADC_InitStructure;
Int32U Conversion_Value;

  /* ADC Structure Initialization */
  ADC_StructInit(&ADC_InitStructure);

  /* Configure the ADC in continuous mode conversion */
  ADC_InitStructure.ADC_Channel_0_Mode = ADC_NoThreshold_Conversion;
  ADC_InitStructure.ADC_Channel_1_Mode = ADC_NoThreshold_Conversion;
  ADC_InitStructure.ADC_Channel_2_Mode = ADC_NoThreshold_Conversion;
  ADC_InitStructure.ADC_Channel_3_Mode = ADC_NoThreshold_Conversion;
  ADC_InitStructure.ADC_Channel_4_Mode = ADC_NoThreshold_Conversion;
  ADC_InitStructure.ADC_Channel_5_Mode = ADC_NoThreshold_Conversion;
  ADC_InitStructure.ADC_Channel_6_Mode = ADC_NoThreshold_Conversion;
  ADC_InitStructure.ADC_Channel_7_Mode = ADC_NoThreshold_Conversion;
  ADC_InitStructure.ADC_Select_Channel = Channel;
  ADC_InitStructure.ADC_Scan_Mode = DISABLE;
  ADC_InitStructure.ADC_Conversion_Mode = ADC_Single_Mode;

  /* Enable the ADC */
  ADC_Cmd(ENABLE);

  /* Prescaler config */
  ADC_PrescalerConfig(0x0);

  /* Configure the ADC */
  ADC_Init(&ADC_InitStructure);

  /* Start the conversion */
  ADC_ConversionCmd(ADC_Conversion_Start);

  /* Wait until conversion completion */
  while(ADC_GetFlagStatus(ADC_FLAG_ECV) == RESET);

  /* Get the conversion value */
  Conversion_Value = ADC_GetConversionValue(Channel);

  /* Clear the end of conversion flag */
  ADC_ClearFlag(ADC_FLAG_ECV);

  return(Conversion_Value);
}


Int32U TestTrim (void)
{
Int32U tmp=0,i;

  /* GPIO Initialization */
  /* GPIO4 Clock Enable */
  SCU_APBPeriphClockConfig(__GPIO4, ENABLE);
  /* GPIO4 Configuration */
  GPIO_ANAPinConfig(GPIO_ANAChannel5,ENABLE);

  /* ADC Clock Enable */
  SCU_APBPeriphClockConfig(__ADC, ENABLE);    /* Enable the clock for the ADC */
  ADC_DeInit();                               /* ADC Deinitialization */

  for (i=0;i<16;++i)
  {
    tmp += AdcConvertion(ADC_Channel_5);
  }
  return(tmp >> 4);
}

Int32U TestJoystick (void)
{
Int32U tmp=0,i;

  /* GPIO Initialization */
  /* GPIO4 Clock Enable */
  SCU_APBPeriphClockConfig(__GPIO4, ENABLE);
  /* GPIO4 Configuration */
  GPIO_ANAPinConfig(GPIO_ANAChannel4,ENABLE);

  /* ADC Clock Enable */
  SCU_APBPeriphClockConfig(__ADC, ENABLE);    /* Enable the clock for the ADC */
  ADC_DeInit();                               /* ADC Deinitialization */

  for (i=0;i<16;++i)
  {
    tmp += AdcConvertion(ADC_Channel_4);
  }
  return(tmp >> 4);
}

Int32U AdcTest (void)
{
Int32U Val;
Int32U i,j;
  /* ADC Clock Enable */
  SCU_APBPeriphClockConfig(__ADC, ENABLE);    /* Enable the clock for the ADC */
  ADC_DeInit();                               /* ADC Deinitialization */
  /* Gonfigure P4.0*/
  GPIO_ANAPinConfig(GPIO_ANAChannelALL,ENABLE);

  for(i = 0; ConvChannels[i] != 0xFF; ++i )
  {
    Val = 0;
    for(j = 16; j; --j)
    {
      Val += AdcConvertion(ConvChannels[i]);
    }
    Val >>= 4;
    Val_Watch = Val;
    if((Val < AdcThresholds[i].Min) || (AdcThresholds[i].Max < Val))
    {
      return (i+1);
    }
  }
  return(0);
}
